// parse thru all links, and rewrite external links
// links with not the same (sub)domain as host.

// register mouseover event to body
// parse all external links and send to server.
// inject js in page to handle response.
// read response and wait for action.

no_nsfw = {
	load : function () {
		this.prefs = Components.classes ["@mozilla.org/preferences-service;1"].getService (Components.interfaces.nsIPrefBranch);

		var appcontent = document.getElementById ("appcontent");
	
		if (! no_nsfw.enabled ()) {
			var icon = document.getElementById ('no-nsfw-panel');
			var toggle = document.getElementById ('no-nsfw-toggle');
			
			toggle.setAttribute ('label', 'Enable');
			toggle.setAttribute ('tooltiptext', 'Enable No-NSFW');

			icon.setAttribute ('src', 'chrome://no-nsfw/content/magnifier-disabled.png');
			icon.setAttribute ('tooltiptext', 'No-NSFW Disabled.');
		}

		if (appcontent) {
			appcontent.addEventListener ("DOMContentLoaded", this.page_load, true);
		}
	},
	
	page_load : function (e) {
		// Go thru DOM and rewrite all external URLs.
		var doc = e.originalTarget;

		if (doc.nodeName!="#document")
			return;

		// **** perhpas issues with "this" ?
		if (! no_nsfw.enabled ())
			return;

		var domain = no_nsfw.domain (doc.location.href);

		// don't clean nonsfw.com
		if (domain == 'http://nonsfw.com')
			return;
	
		// both suffer from active window syndrome ! - FIXED

		// inject page js.
		no_nsfw.js ('chrome://no-nsfw/content/page.js', doc);

		// inject css ?
		no_nsfw.css ('chrome://no-nsfw/content/page.css', doc);

		// page.js has no access to prefs.js - so variables have to be written and rewritten
		// no_nsfw.jsvar ('no_nsfw_domain = '+no_nsfw.host (), doc);
	},
	
	
	discuss : function () {
		var loc = window.content.document.location.href;
		window.content.document.location = 'http://nonsfw.com/info/'+loc;
	},
	
	vote : function (type) {
		// type could be either 'nsfw' or 'sfw'
		var doc = window.content.document;
		var loc = doc.location.href;
		var id = 'no-nsfw-vote-' + type;
	
		// just call, forget response ?
		// need to record IP ? to prevent multiple logins ?
		this.js ('http://nonsfw.com/ajax/'+type+'?url=' + this.esc (loc));

		doc.getElementById (id).style.display = 'block';
		doc.getElementById (id).style.left = doc.getElementById (id).style.left = (window.innerWidth - 141) + 'px';

		setTimeout (function () {
			doc.getElementById (id).style.display = 'none';
		}, 2000);
	},
	
	// extract domain from url.
	domain : function (url) {
		var parts = url.match (/^http:\/\/[^\/]*/);
		return parts [0];
	},

	// get host
	host : function () {
		try {
			return this.prefs.getCharPref ("extensions.no-nsfw.domain");
		} catch (e) {
			return 'nonsfw.com';
		}
	},

	enabled : function () {
		try {
			return this.prefs.getBoolPref ("extensions.no-nsfw.enabled");
		} catch (e) {
			return true;
		}
	},

	toggle : function () {
		var icon = document.getElementById ('no-nsfw-panel');
		var toggle = document.getElementById ('no-nsfw-toggle');
	
		try {
			this.prefs.setBoolPref ("extensions.no-nsfw.enabled", !this.enabled ());

			if (! this.enabled ()) {
				toggle.setAttribute ('label', 'Enable');
				toggle.setAttribute ('tooltiptext', 'Enable No-NSFW');

				icon.setAttribute ('src', 'chrome://no-nsfw/content/magnifier-disabled.png');
				icon.setAttribute ('tooltiptext', 'No-NSFW Disabled.');
			} else {
				toggle.setAttribute ('label', 'Disable');
				toggle.setAttribute ('tooltiptext', 'Disable No-NSFW');

				icon.setAttribute ('src', 'chrome://no-nsfw/content/magnifier.png');
				icon.setAttribute ('tooltiptext', 'No-NSFW Enabled.');
			}
		} catch (e) {

		}
	},

	js : function (url, doc) {
		if (typeof doc == 'undefined')
			doc = window.content.document;

		var elem = doc.createElement ('script');
		elem.setAttribute ('src', url);
		elem.setAttribute ('type','text/javascript');
		doc.getElementsByTagName ('head') [0].appendChild (elem);
	},

	css : function (url, doc) {
		if (typeof doc == 'undefined')
			doc = window.content.document;

		var elem = doc.createElement ('link');
		elem.setAttribute ('href', url);
		elem.setAttribute ('rel', 'stylesheet');
		elem.setAttribute ('type','text/css');
		doc.getElementsByTagName ('head') [0].appendChild (elem);
	},

	esc : function (url) {
		var escurl;
		try {
			escurl = encodeURIComponent (url);
		} catch(e) {
			escurl = escape(url);
		}
		return escurl;
	}
};
